#
# This file is used to create the binary distribution package
# ALDORROOT should be provided from the environment
#

CP=cp
RM=rm

GENERATOR	= "c:/Program Files/NSIS/makensis"
KIT		= $(ALDORROOT)/../

SCRIPT = gccgenerated.nsi

all: cleanbinary generated.nsi license.txt Readme.txt
	$(CP) $(SCRIPT) $(KIT)
	$(CP) license.txt $(KIT)
	$(CP) Readme.txt $(ALDORROOT)
	(cd $(KIT); $(GENERATOR) /DALDORROOT=`cygpath -w $(ALDORROOT)` /DMACHINE=$(MACHINE) /DVERSION=$(ALDOR_VERSION) $(SCRIPT) )

clean: 
	@$(RM) $(KIT)/$(SCRIPT)
	@$(RM) $(KIT)/lincense.txt
	@$(RM) $(ALDORROOT)/Readme.txt

cleanbinary:
	@echo "Cleaning binaries"
	@$(RM) -f $(ALDORROOT)/bin/*.ilk
	@$(RM) -f $(ALDORROOT)/bin/*.pdb
	@$(RM) -f $(ALDORROOT)/lib/*.fm
	@$(RM) -rf $(ALDORROOT)/srclib
	@$(RM) -rf $(ALDORROOT)/share
